/*
 * This file is part of VoidArchiveTool.
 *
 * Copyright (C) 2025 Yanczi
 *
 * Void Archive Toolis free software: you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public License
 * along with this program.  If not, see <https://www.gnu.org/licenses/>.
 */

#pragma once

#include <sodium.h>
#include <vector>
#include <array>
#include <stdexcept>
#include <fstream>
#include <ctime>
#include <iostream>
#include <xxhash.h>
#include <sstream>
#include <iomanip>
#include <algorithm>

#include "DataStruct.h"

class EncryptionManager
{
public:
	EncryptionManager();
	~EncryptionManager() = default;

	std::vector<char> encrypt(const std::vector<char>&);
	std::vector<char> decrypt(const std::vector<char>&);

	void saveKey(const std::string&, bool);
	void loadKey(const std::string&);

	// Generowanie hash BLAKE2b
	//static std::array<char, 16> hashBlake(const std::vector<char>&);
	//static bool compareBlake(const std::vector<char>&, const std::array<char, 16>&);

private:
	std::array<unsigned char, crypto_stream_chacha20_ietf_KEYBYTES> key{};
	bool keyReady;

	void generateKeys();
	std::string toHex(const unsigned char*, size_t);
	void saveCppHeadFile(const std::string&);

	template <size_t N>
	std::array<unsigned char, N> toArray(const std::vector<char>& vec) {
		if (vec.size() < N) {
			throw std::runtime_error("Too small vector to convert to array");
		}

		std::array<unsigned char, N> arr{};
		std::memcpy(arr.data(), vec.data(), N);
		return arr;
	}
};